<?php

 // Spamtram version 1.0 Copyright (c) 2006 Geekministry.com


class ValidateForm {

  var $fields;
  var $mandatory;
  var $mandatory_mail;
  var $mandatory_number;
  var $error="";

   function ValidateForm(){
      while(list($key,$value) = each($_REQUEST)){
        // If Array convert to one string
        if (is_array($value)){
           $value = join(';',$value);
        }
        $this->fields[$key] = trim($value);
     }

  }

   function addCheck($field){
    $this->mandatory[] = $field;
  }

   function addCheckEmail($field){
    $this->mandatory_mail[] = $field;
  }

   function addCheckNumber($field){
    $this->mandatory_number[] = $field;
  }

   function validate(){
    $validate_check = true;

    for ($i=0;$i<count($this->mandatory);$i++){
         if ($this->fields[$this->mandatory[$i]] == "" || strlen($this->fields[$this->mandatory[$i]]) < 1){
             $validate_check = false;
             $this->error .= "Please fill in " . str_replace('_',' ',$this->mandatory[$i]). "<br />";
         }
    }

    for ($i=0;$i<count($this->mandatory_mail);$i++){
         if ($this->fields[$this->mandatory_mail[$i]] == "" || strlen($this->fields[$this->mandatory_mail[$i]]) < 1){
             $validate_check = false;
             $this->error .= "Please fill in " . str_replace('_',' ',$this->mandatory_mail[$i]) . "<br />";
             break;
         }

         if (!preg_match("/[a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9]{2,4}/",$this->fields[$this->mandatory_mail[$i]])){
             $validate_check = false;
             $this->error .= "The email address" . str_replace('_',' ',$this->fields[$this->mandatory_mail[$i]]) . " is not valid<br />";
         }
    }

    for ($i=0;$i<count($this->mandatory_number);$i++){
         if ($this->fields[$this->mandatory_number[$i]] == "" || strlen($this->fields[$this->mandatory_number[$i]]) < 1){
             $validate_check = false;
             $this->error .= "Please fill in " . str_replace('_',' ',$this->mandatory_number[$i]) . "<br />";
             break;
         }

         if (!$this->isNumber($this->fields[$this->mandatory_number[$i]])){
             $validate_check = false;
             $this->error .= "The number " . str_replace('_',' ',$this->fields[$this->mandatory_number[$i]]) . " is not correct<br />";
         }
    }

    return  $validate_check;
  }

  function isNumber($value){
     $numbers="0123456789";
     $check_number=true;
     for($i=0;$i<strlen($value);$i++){
       if (strpos($numbers,$value[$i]) == "" || strpos($numbers,$value[$i]) == -1)
         $check_number = false;
     }
     return $check_number;
  }

  function getError(){
    return $this->error;
  }

  function get($name){
    return $this->fields[$name];
  }

  function set($name,$value){
    $this->fields[$name] = trim($value);
  }
  
}

?>